#define EXTENSION_NAME FNAL
#define LIB_NAME "FNAL"
#define MODULE_NAME "fnal"

// include the Defold SDK
#include <dmsdk/sdk.h>
#include <string.h>
#include <easyhttpcpp/EasyHttp.h>

static int FNAL_Log(lua_State* L)
{
    // The number of expected items to be on the Lua stack
    // once this struct goes out of scope
    DM_LUA_STACK_CHECK(L, 1);

    // Check and get parameter string from stack
    char* str = (char*)luaL_checkstring(L, 1);

    // Reverse the string
    int len = strlen(str);
    for(int i = 0; i < len / 2; i++) {
        const char a = str[i];
        const char b = str[len - i - 1];
        str[i] = b;
        str[len - i - 1] = a;
    }

    // Put the reverse string on the stack
    lua_pushstring(L, str);

    // Return 1 item
    return 1;
}

// Functions exposed to Lua
static const luaL_reg FNAL_Methods[] =
{
    {"log", FNAL_Log},
    {0, 0}
};

static void LuaInit(lua_State* L)
{
    int top = lua_gettop(L);
    luaL_register(L, MODULE_NAME, FNAL_Methods);
    lua_pop(L, 1);
    assert(top == lua_gettop(L));
}

dmExtension::Result AppInitializeFNAL(dmExtension::AppParams* params)
{
    dmLogInfo("[FNAL] Registered Extension!");
    return dmExtension::RESULT_OK;
}

dmExtension::Result AppFinalizeFNAL(dmExtension::AppParams* params)
{
    return dmExtension::RESULT_OK;
}

dmExtension::Result InitializeFNAL(dmExtension::Params* params)
{
    dmLogInfo("[FNAL] Initializing Extension...");
    return dmExtension::RESULT_OK;
}

dmExtension::Result UpdateFNAL(dmExtension::Params* params)
{
    return dmExtension::RESULT_OK;
}

dmExtension::Result FinalizeFNAL(dmExtension::Params* params)
{
    dmLogInfo("[FNAL] Finalizing Extension...");
    return dmExtension::RESULT_OK;
}



DM_DECLARE_EXTENSION(EXTENSION_NAME, LIB_NAME, AppInitializeFNAL, AppFinalizeFNAL, InitializeFNAL, UpdateFNAL, 0, FinalizeFNAL)